<?php
/*
 * [NOS][SNA] (C)2007-2011 Maiyun.NET
 * This is NOT a freeware, use is subject to license terms.
 *
 * Log: 2011-11-3 22:00:43 8 yunboo
*/

include_once('../include/core.inc.php');

$NodeInfo = read_data('node');
$LeechInfo = read_data('leech');

$db = new mysql;
$db->Connect();

// --- 判断防盗链 ---

$GoOn = true;
if($LeechInfo['open']) {
	if(($Referet = @parse_url($_SERVER['HTTP_REFERER'])) !== false) {
		$ReferetHost = isset($Referet['host']) ? $Referet['host'] : '';
		if(stripos($LeechInfo['white'],'['.$ReferetHost.']') === false) {
			$GoOn = false;
		}
	} else {
		$GoOn = false;
	}
}

if($GoOn) {
	// --- 获取附件 ---
	if($File = $db->Fetch($db->Query('SELECT * FROM `'.$db->TPre.'attachment` WHERE `key` = "'.$db->GetSafeString($_GET['key']).'" AND `aid` = '.($_GET['id']+0).';'))) {
		// --- 判断实体文件 ---
		if(is_file(ROOT_PATH.$File['path'])) {
			// --- 检查用户限速 ---
			$json = new Services_JSON();
			if(isset($_COOKIE['mnos_login_user_'.COOKIE_PRE])) {
				$GroupInfoStr = http_post($NodeInfo['site_url'].'api/group/me/', 'mnos_ukey='.$_COOKIE['mnos_login_user_'.COOKIE_PRE]);
			}
			else
				$GroupInfoStr = http_post($NodeInfo['site_url'].'api/user/guest/');
			// --- 解析 JSON ---
			$GroupInfo = $json->decode($GroupInfoStr);
			$DownSpeed = $GroupInfo->down_speed;
			// --- 断点续传判断 ---
			$IsHttpRange = false;
			if(isset($_SERVER['HTTP_RANGE']) && ($_SERVER['HTTP_RANGE']!='')) $IsHttpRange = true;
			// --- 开始输出文件 ---
			@set_time_limit(0);
			header('Content-type: application/octet-stream');
			header('Accept-Ranges: bytes');
			header('Pragma: no-cache');
			header('Cache-Control: max-age=0');
			header('Expires: -1');
			// --- 打开文件 ---
			$fh = fopen(ROOT_PATH.$File['path'],'r');
			// --- 根据浏览器设置文件名 ---
			if(strpos(strtolower($_SERVER['HTTP_USER_AGENT']),'firefox') !== false) {
				header('Content-Disposition: attachment; filename="'.$File['name'].'"');
			} else {
				header('Content-Disposition: attachment; filename="'.urlencode($File['name']).'"');
			}
			// --- 判断是否是断点 ---
			if($IsHttpRange) {
				// --- 是断点 ---
				$LowerHttpRange = str_replace('bytes=','',trim(strtolower($_SERVER['HTTP_RANGE'])));
				list($HttpRangeMin,$HttpRangeMax) = explode('-', $LowerHttpRange);
				if($HTTPRangeMin==0) {
					$IsHttpRange = false;
				} else {
					fseek($fh, $HttpRangeMin);
					header('Content-Length: '.($File['size']-1-$HttpRangeMin));
					header('Content-Range: bytes '.$HttpRangeMin.'-'.($File['size']-1).'/'.$File['size']);
					header('HTTP/1.1 206 Partial Content');
				}
			}
			if(!$IsHttpRange) {
				// --- 不是断点，下载次数计数 ---
				$db->Query('UPDATE `'.$db->TPre.'attachment` SET `down_count` = `down_count` + 1 WHERE `aid` = '.$File['aid'].';');
				header('Content-Range: bytes 0-'.($File['size']-1).'/'.$File['size']);
				header('Content-Length: '.$File['size']);
			}
			// --- 开始输出文件 ---
			while(!feof($fh)) {
				if($DownSpeed == 0) {
					// --- 不限速 ---
					echo fread($fh, 8192);
					ob_flush();
					flush();
				} else {
					// --- 需要限速 ---
					if($DownSpeed <= 8192) {
						echo fread($fh, $DownSpeed);
						ob_flush();
						flush();
					} else {
						$EchoSize = 0;
						// --- 若相等则表示已经输出完了 ---
						for(;$EchoSize < $DownSpeed;) {
							if(($DownSpeed - $EchoSize) > 8192) {
								// --- 如果此阶段限制大小还是大于应输大小 ---
								echo fread($fh, 8192);
								$EchoSize += 8192;
							} else {
								// --- 小于或等于应输大小 ---
								echo fread($fh, $DownSpeed - $EchoSize);
								$EchoSize += $DownSpeed - $EchoSize;
							}
							ob_flush();
							flush();
						}
					}
					sleep(1);
				}
			}
			// --- 输出完毕终结 ---
			fclose($fh);
		} else {
			header('Location: '.$NodeInfo['site_url'].'?location=nofile');
		}
	} else {
		header('Location: '.$NodeInfo['site_url'].'?location=noattach');
	}
} else {
	header('Location: '.$NodeInfo['site_url'].'?location=white');
}

$db->Quit();

